local original_raid_list_data_source = MissionSelectionGui._raid_list_data_source

function MissionSelectionGui:_raid_list_data_source()
	local raid_list = original_raid_list_data_source(self)
	self.number_of_items = #raid_list
	return raid_list
end

Hooks:PostHook(MissionSelectionGui, "_layout", "choose_random_raid_layout", function(self)
	self:_layout_random_button()
end)

function MissionSelectionGui:_layout_random_button()
	local raid_random_button_params = {
		name = "raid_random_button",
		x = self._raid_list:x() + self._raid_list:w() - self._raid_start_button:x() - self._save_delete_button:w(),
		layer = 1,
		y = self._settings_panel:y() + self._settings_panel:h() + 248,
		text = "RANDOMIZE",
		on_click_callback = callback(self, self, "_on_random_button_click")
	}
	self._raid_random_button = self._raid_panel:short_secondary_button(raid_random_button_params)

	self._raid_random_button:set_center_y(864)
end

function MissionSelectionGui:_on_random_button_click()
	local items = self.number_of_items
	if (items == nil) then
		return
	end
	self._raid_list:select_item_by_index(math.random(1, items))
	-- _reposition_selected_item() scrolls towards selected item
	self._raid_list:_reposition_selected_item()
end

Hooks:PostHook(MissionSelectionGui, "_select_raids_tab", "choose_random_raid_select_raids_tab", function(self)
	if (not self._raid_random_button) then return end
	self._raid_random_button:animate_show()
end)

Hooks:PostHook(MissionSelectionGui, "_select_operations_tab", "choose_random_raid_select_op_tab", function(self)
	if (not self._raid_random_button) then return end
	self._raid_random_button:animate_hide()
end)
